{% extends "layout.jinja" %}
{% block title %}Register{% endblock %}
{% block body %}
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

<br>
<div class="media">
    {% if profile_url != "" %}
    <img src="{{ profile_url }}" class="mr-3">
    {% endif %}
    <div class="media-body">
        <h4 class="mt-0">{{ name }} has invited you to Breadpirates.chat</h4>
        You've been invited to join the Breadpirates.chat homeserver.
        Fill in the form below to create your account.
    </div>
</div>
<form id="regForm" method="post" action="do_registration" onsubmit="event.preventDefault(); validateFields(true);">
    <input type="hidden" name="token" value="{{ token }}">
    <div class="form-group">
        <label for="username">Username</label>
        <input name="username" type="text" class="form-control" id="username" aria-describedby="usernameHelp" placeholder="Enter username" onblur="validateFields()">
        <small id="usernameHelp" class="form-text text-muted">Username must be at least 3 characters long and can only contain characters a-z, 0-9, ., _, =, - and /</small>
        <small id="usernameError" class="form-text" style="color: red"></small>
    </div>
    <div class="form-group">
        <label for="password">Password</label>
        <input name="password" type="password" class="form-control" id="password" placeholder="Enter password" onblur="validateFields()">
        <small id="passwordHelp" class="form-text text-muted">Password must be at least 12 characters long</small>
        <small id="password1Error" class="form-text" style="color: red"></small>
    </div>
    <div class="form-group">
        <label for="password2">Repeat Password</label>
        <input name="password2" type="password" class="form-control" id="password2" placeholder="Enter password again" onblur="validateFields()">
        <small id="password2Error" class="form-text" style="color: red"></small>
    </div>
    <!--
    <div class="custom-control custom-checkbox">
        <input name="tosagree" type="checkbox" class="custom-control-input" id="tosAgree">
        <label class="custom-control-label" for="tosAgree">I have read and agree to the Terms of Service and Rules</label>
        <small id="tosError" class="form-text" style="color: red"></small>
    </div> #}-->
    <button type="submit" class="btn btn-primary">Register</button>
</form>
<script>
    function validateFields(onSubmit) {
        var username = document.getElementById("username");
        var pw1 = document.getElementById("password");
        var pw2 = document.getElementById("password2");
        var usernameError = document.getElementById("usernameError");
        var pw1Error = document.getElementById("password1Error");
        var pw2Error = document.getElementById("password2Error");
        // var tosError = document.getElementById("tosError");
        // var tos = document.getElementById("tosAgree");
        var usernameRegex = /[^A-Za-z0-9\._\-\=]/g;
        var form = document.getElementById("regForm");

        if (onSubmit && username.value.length == 0) {
            usernameError.innerHTML = "Username cannot be empty.";
            return false;
        }

        if (username.value.length < 3 && username.value.length != 0) {
            usernameError.innerHTML = "Username must be at least 3 characters long.";
            return false;
        } else {
            usernameError.innerHTML = "";
        }

        if (usernameRegex.test(username.value)) {
            usernameError.innerHTML = "Username contains invalid characters.";
            return false;
        }

        if (onSubmit && pw1.value.length == 0) {
            pw1Error.innerHTML = "Passsword cannot be empty.";
            return false;
        }

        if (pw1.value.length < 12 && pw1.value.length != 0) {
            pw1Error.innerHTML = "Password is too short.";
            return false;
        } else {
            pw1Error.innerHTML = "";
        }

        if (pw1.value != pw2.value && pw1.value.length != 0) {
            pw2Error.innerHTML = "Passwords do not match.";
            return false;
        } else {
            pw2Error.innerHTML = "";
        }

        // if (!tos.checked && onSubmit) {
        //    tosError.innerHTML = "You must agree to the ToS and read the rules before creating an account.";
        //    return false;
        //} else {
        //    tosError.innerHTML = "";
        //}

        if (onSubmit) {
            regForm.submit();
        }

        return true;
    }
</script>
{% endblock %}